%define __check_files %{nil}
%define debug_package %{nil}

Name:      dre-core
Version:   1.1
Release:   1%{?dist}
Summary:   %{name} : Core package of D-RE(DEOS Runtime Environment).
Group:     Applications/System
License:   GPL2
URL:       http://www.dependable-os.net/
Source:    %{name}-%{version}.tar.gz
BuildRoot: %(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
Requires:  daware-mod %{name}-minimal

%description
Core package of D-RE(DEOS Runtime Environment).

%package -n %{name}-minimal
Summary:   %{name} : Core package of D-RE(DEOS Runtime Environment).
Group:     Applications/System
Requires:  daware-mod

%description -n %{name}-minimal
Core package of D-RE(DEOS Runtime Environment).

%prep
%(mkdir -p %{_topdir}/SOURCES/)
%setup -q

%build
rm -rf ${RPM_BUILD_ROOT}
make

%install
rm -rf ${RPM_BUILD_ROOT}
install -d ${RPM_BUILD_ROOT}/var/lib/dre/containers/application
install -d ${RPM_BUILD_ROOT}/var/lib/dre/containers/system
install -d ${RPM_BUILD_ROOT}/usr/share/doc/%{name}
make install DESTDIR=${RPM_BUILD_ROOT}

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%defattr(-,root,root)
%dir /var/lib/dre/containers/application
%dir /var/lib/dre/containers/system
%{_prefix}/sbin/*
%{_datadir}/*
%{_sysconfdir}/*

%files -n %{name}-minimal
%defattr(-,root,root)
%dir /var/lib/dre/containers/application
%{_prefix}/sbin/dre-app
%{_prefix}/sbin/dre-cgroup
%{_datadir}/doc/%{name}/dre-app.txt
%{_datadir}/doc/%{name}/dre-cgroup.txt
%{_sysconfdir}/*

%changelog
* Fri Jan 17 2014 JST DEOS R&D Center <dtools2@dependable-os.net>
- daily build

* Fri Dec 14 2012 JST DEOS R&D Center <dtools2@dependable-os.net>
- Initial Release.

%post
. /etc/default/dre
# dre-admin
if [ -z "`grep -w ^${DRE_ADMIN_GROUP} /etc/group`" ]; then
    groupadd --system ${DRE_ADMIN_GROUP}
fi
if [ -z "`grep -w ^${DRE_ADMIN} /etc/passwd`" ]; then
    useradd -g ${DRE_ADMIN_GROUP} --system --no-create-home --home-dir ${DRE_ROOT} --shell /bin/sh ${DRE_ADMIN}
    usermod -p '*' ${DRE_ADMIN}
fi
# container directories
mkdir -p ${DRE_APP_CONTAINER_PATH}
mkdir -p ${DRE_SYS_CONTAINER_PATH}
# sudoers
chmod 440 ${DRE_SUDOERS}
chown 0:0 ${DRE_SUDOERS}
# ssh
mkdir -p ${DRE_MOTD_CACHE_PATH}
mkdir -p ${DRE_RSA_PATH}
chown -R ${DRE_ADMIN} ${DRE_ROOT}
chown -R ${DRE_ADMIN}:${DRE_ADMIN_GROUP} ${DRE_RSA_PATH}
chmod 700 ${DRE_RSA_PATH}
sudo -u ${DRE_ADMIN} ssh-keygen -q -N "" -t rsa -f ${DRE_RSA_LOCALHOST}
sudo -u ${DRE_ADMIN} mv ${DRE_RSA_PATH}/dre.pub ${DRE_RSA_PATH}/authorized_keys
sudo -u ${DRE_ADMIN} chmod 600 ${DRE_RSA_PATH}/authorized_keys

%postun
. /etc/default/dre
# dre-admin
if [ ! -z "`grep -w ^${DRE_ADMIN} /etc/passwd`" ]; then
    userdel ${DRE_ADMIN}
fi
gid=`grep -w ^${DRE_ADMIN_GROUP} /etc/group | awk -F: '{print $3}'`
if [ ! -z ${gid} ]; then
    if [ -z "`cat /etc/passwd | awk -F: '{print $4}' | grep -w ${gid}`" ]; then
        groupdel ${DRE_ADMIN_GROUP}
    fi
fi
# ssh
rm -f ${DRE_RSA_LOCALHOST}

